unit Unit1;

{ Doubly linked integer list demo form for TLListInt object }
{ by Alexander Wernhart wea@felten.co.at }
{ See comments in the LLinstInt unit. }
{ based on: }
{ Doubly linked list demo form for TLink object }
{ by Jeff Atwood, JAtwood159@AOL.COM. }
{ }

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, LlistInt, ExtCtrls;

type
  TForm1 = class(TForm)
    ListBox1: TListBox;
    GroupBox1: TGroupBox;
    Edit1: TEdit;
    radTop: TRadioButton;
    radMiddle: TRadioButton;
    radBottom: TRadioButton;
    btnDel: TButton;
    Label1: TLabel;
    Label2: TLabel;
    btnAdd: TButton;
    btnFind: TButton;
    Label4: TLabel;
    Label5: TLabel;
    btnCancel: TButton;
    Label3: TLabel;
    lblCount: TLabel;
    Label6: TLabel;
    LListInt1: TLListInt;
    procedure btnAddClick(Sender: TObject);
    procedure btnFindClick(Sender: TObject);
    procedure btnDelClick(Sender: TObject);
    procedure btnCancelClick(Sender: TObject);
  private
    procedure FillList(listbox: TListBox; list: TLListInt);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
procedure TForm1.btnAddClick(Sender: TObject);
var
  temp: integer;
begin
  temp := StrtoInt(Edit1.Text);

  { add the item }
  if radTop.Checked then
    LListInt1.Insert(temp,0);
  if radBottom.Checked then
    LListInt1.Add(temp);
  if radMiddle.Checked then
  begin
    if Listbox1.Itemindex <> -1 then
    begin
      LListInt1.Insert(temp,Listbox1.Itemindex);
    end else
    begin
      showmessage('No item selected for insert!');
    end;
  end;

  { refresh display }
  FillList(ListBox1, LListInt1);
  lblCount.Caption := inttostr(LListInt1.Itemcount);

  { increment data }
  Edit1.Text := IntToStr(temp + 1);
end;

procedure TForm1.btnFindClick(Sender: TObject);
var
  retval: Integer;
  loc: longint;
begin
  loc := LListInt1.FindFirst(StrToInt(Edit1.Text)) + 1;
  if not (loc < 1) then
    showmessage('Item ' + Edit1.Text + ' is at position ' + intToStr(loc))
  else
    showmessage('Item ' + Edit1.Text + ' not in list.');
end;

procedure TForm1.btnDelClick(Sender: TObject);
var
 x: integer;
begin
  if not (Listbox1.itemindex < 0) then
  begin
    LListInt1.Delete(Listbox1.ItemIndex);
    { refresh display }
    FillList(ListBox1, LListInt1);
    lblCount.Caption := inttostr(LListInt1.ItemCount);
  end;
end;

procedure TForm1.btnCancelClick(Sender: TObject);
begin
  Close;
end;

{ fill a list box with TLListInt entries }
procedure TForm1.FillList(listbox: TListBox; list: TLListInt);
var
  temp: Integer;
  olditem: Integer;
  i: Integer;
begin
  { save old position so we don't lose it }
  olditem := listbox.ItemIndex;
  { clear the list box }
  listbox.Clear;

  for i := 0 to (list.Itemcount - 1) do
  begin
      listbox.Items.Add(IntToStr(list.Item[i]));
  end;

  { reset position }
  if olditem < listbox.Items.Count then
    listbox.ItemIndex := olditem
  else
    listbox.ItemIndex := listbox.Items.Count - 1;

end;

end.
